--[[
###############
Inked: keivamp#
###############
]]--
local Inked = LibStub("AceAddon-3.0"):GetAddon("Inked")
local LSM = LibStub("LibSharedMedia-3.0")
local playerColor = RAID_CLASS_COLORS[select(2, UnitClass('player'))]
local InkedColors = {r = playerColor.r*0.75, g = playerColor.g*0.75,b = playerColor.b*0.75,a = 1}

local _, ns = ...
local oUF = ns.oUF
local addonName, addon = ...

local function CreateBackdrop(frame)
   frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = 0, left = 0, bottom = 0, right = 0}})
		frame:SetBackdropColor(0,0,0,0.75)
	
end
local function CreateHealthBackdrop(frame)
    frame:SetBackdrop({bgFile = "Interface\\TargetingFrame\\UI-StatusBar"})
    frame:SetBackdropColor(0.35,0.1,0.1,0.85)
	frame:SetBackdropBorderColor(0,0,0,1)
end

local function CreatePowerBackdrop(frame)
      frame:SetBackdrop({bgFile = "Interface\\TargetingFrame\\UI-StatusBar"})
		frame:SetBackdropColor(0.25,0.25,0.75,0.75)
	frame:SetBackdropBorderColor(0,0,0,1)
end

local function CreateBackdrop(frame)
      frame:SetBackdrop({bgFile = "Interface\\TargetingFrame\\UI-StatusBar"})
		frame:SetBackdropColor(0,0,0,0.75)
		frame:SetBackdropBorderColor(0,0,0,0)
end
local function CreateMoverBackdrop(frame)
   frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = -2, left = -2, bottom = -2, right = -2}})
		frame:SetBackdropColor(0,0.55,0.95,0.45)
		frame:SetBackdropBorderColor(0,0,0,1)
end
local function HealthWrap(frame)
	local HealthWrapper = CreateFrame("Frame","ButtonForegroundTexture",frame, BackdropTemplateMixin and "BackdropTemplate")
		HealthWrapper:SetPoint("LEFT",frame,"LEFT",-5,0)
		HealthWrapper:SetSize(105,27)
		HealthWrapper:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
		edgeFile = "Interface\\Addons\\Inked\\Graphics\\Borders\\PsychoBorder",
		edgeSize = 16,
		insets = {top = 4, left = 4, bottom = 4, right = 4}})
		HealthWrapper:SetBackdropColor(0,0,0,0)
		HealthWrapper:SetBackdropBorderColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
end
local function PowerWrap(frame)
	local PowerWrapper = CreateFrame("Frame","ButtonForegroundTexture",frame, BackdropTemplateMixin and "BackdropTemplate")
		PowerWrapper:SetPoint("LEFT",frame,"LEFT",-5,0)
		PowerWrapper:SetSize(105,22)
		PowerWrapper:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
		edgeFile = "Interface\\Addons\\Inked\\Graphics\\Borders\\PsychoBorder",
		edgeSize = 16,
		insets = {top = 4, left = 4, bottom = 4, right = 4}})
		PowerWrapper:SetBackdropColor(0,0,0,0)
		PowerWrapper:SetBackdropBorderColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
end
local TartgetTargetMover = CreateFrame("Frame","TargetTargetDrag",UIParent, BackdropTemplateMixin and "BackdropTemplate")
	TartgetTargetMover:SetSize(132,55)
	TartgetTargetMover:SetPoint("CENTER",UIParent,235,-335)
	
	TartgetTargetMover:SetClampedToScreen(true)
	TartgetTargetMover:SetClampRectInsets(0, 0, 0,0)
	
local TartgetTargetMoverText  = TartgetTargetMover:CreateFontString(nil, "OVERLAY")
	TartgetTargetMoverText:SetFont("Interface\\Addons\\Inked\\Fonts\\Cooline.ttf", 16, "OUTLINE")
	TartgetTargetMoverText:SetPoint("CENTER",TartgetTargetMover,"CENTER", 0,0); 
	TartgetTargetMoverText:SetText("")
	
	local function UpdateMe()
	if(Inked.db.profile.lockframes == false) then
		if Inked.db.profile.FocusFrameEnable == true then 
				Inked.db.profile.ToTX = 0
				Inked.db.profile.ToTY = 0
				local point, relativeTo, relativePoint, xOfs, yOfs = TartgetTargetMover:GetPoint(n)
				Inked.db.profile.ToTX = xOfs
				Inked.db.profile.ToTY = yOfs
				Inked.db.profile.ToTPoint = point
				TartgetTargetMover:SetMovable(true)
				TartgetTargetMover:EnableMouse(true)
				TartgetTargetMover:RegisterForDrag("LeftButton")
				TartgetTargetMover:SetScript("OnDragStart", TartgetTargetMover.StartMoving)
				TartgetTargetMover:SetScript("OnDragStop", TartgetTargetMover.StopMovingOrSizing)
				TartgetTargetMover:SetUserPlaced(true)
				TartgetTargetMoverText:SetText("Target Target")
				CreateMoverBackdrop(TartgetTargetMover)
			end
		end	
end	
	---Update Database check
	local InkedSettingsFrame = CreateFrame("Frame")	
	InkedSettingsFrame:HookScript("OnUpdate",UpdateMe)

local UnitSpecific = {

	targettarget = function(self)
	
		local ToTTargetWidth = 95;
		local ToTTargetHeight = 35;
		self:SetSize(ToTTargetWidth,ToTTargetHeight)

		---------------------------------
		-- Target of Target Neame Text --
		---------------------------------
		if Inked.db.profile.ToTShowName == true then
		local NameText = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		NameText:SetPoint("TOPLEFT", self, 0,15) -- but anchor to the base element so it doesn't wiggle
		NameText:SetJustifyH("LEFT")
		NameText:SetFont(LSM:Fetch("font", Inked.db.profile.ToTNamefont), Inked.db.profile.ToTNameFontSize, Inked.db.profile.ToTNameOutline)
		NameText:SetWidth(300)
		self:Tag(NameText, "[name]") -- oUF will automagically update it!
		end
		----------------------------------
		-- Target of Target Power Value --
		----------------------------------
		if Inked.db.profile.ToTShowPowerPercent == true then
		local PowerText = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		PowerText:SetPoint("CENTER", self, 0,-21) -- but anchor to the base element so it doesn't wiggle
		PowerText:SetFont(LSM:Fetch("font", Inked.db.profile.ToTPowerfont), Inked.db.profile.ToTPowerFontSize, Inked.db.profile.ToTPowerOutline)
		self:Tag(PowerText, "[perpp]".." %") -- oUF will automagically update it!
		PowerText:SetAlpha(1)
		end

		-----------------------------------
		-- Target of Target Health Value --
		-----------------------------------
		if Inked.db.profile.ToTShowHealthPercent == true then
		local HealthText = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		HealthText:SetPoint("CENTER", self, 0,5) -- but anchor to the base element so it doesn't wiggle
		HealthText:SetFont(LSM:Fetch("font", Inked.db.profile.ToTHealthfont), Inked.db.profile.ToTHealthFontSize, Inked.db.profile.ToTHealthOutline)
		self:Tag(HealthText, "[perhp]".." %") -- oUF will automagically update it!
		end

		-------------------------------------------------------
		-- Target of Target Health and Power Bar Adjustments --
		-------------------------------------------------------

		self.Health:SetHeight(25)
		self.Power:SetHeight(20)


	end, -- End Target of Target
	
}


local Shared = function(self, unit)
	-- Shared layout code.
	self:SetScale(Inked.db.profile.ToTScale)

	-----------------
	--  Mouse Code --
	-----------------
	self:SetScript('OnEnter', UnitFrame_OnEnter)
	self:SetScript('OnLeave', UnitFrame_OnLeave)

	self:RegisterForClicks'AnyUp'
	------------------
	--  Health Bars --
	------------------

	local Health = CreateFrame("StatusBar", nil, self, BackdropTemplateMixin and "BackdropTemplate")
	Health:SetStatusBarTexture(LSM:Fetch("statusbar", Inked.db.profile.ToTHealthStatusBar))
	Health:SetPoint('TOP')
	Health:SetPoint('LEFT')
	Health:SetPoint('RIGHT')
	Health:SetFrameLevel(2)
	HealthWrap(Health)
	CreateBackdrop(Health)

	-- Options
	--Health.frequentUpdates = true
	Health.colorTapping = true
	Health.colorDisconnected = true
	Health.colorClass = true
	Health.colorReaction = true
	Health.colorHealth = true
	-- Register it with oUF
	self.Health = Health
	self.Health.bg = Healthbg

    -----------------
	--  Power Bars --
	-----------------

	local Power = CreateFrame("StatusBar", nil, Health, BackdropTemplateMixin and "BackdropTemplate")
	Power:SetStatusBarTexture(LSM:Fetch("statusbar", Inked.db.profile.ToTPowerStatusBar))
	Power:SetPoint('BOTTOM',Health,'BOTTOM',0,-25)
	Power:SetPoint('LEFT')
	Power:SetPoint('RIGHT')
	Power:SetFrameLevel(1)
	PowerWrap(Power)
	CreateBackdrop(Power)
	-- Options
	--Power.frequentUpdates = true
	Power.colorPower = true -- powertype colored bar
	Power.colorClassNPC = false -- color power based on NPC
	Power.colorClassPet = false -- color power based on pet type
	-- Register it with oUF
	self.Power = Power
	self.Power.bg = Powerbg


	-----------------
	-- Smooth Bars --
	-----------------

	self.Health.Smooth = true
		if self.Power then
			self.Power.Smooth = true
		end


	if(UnitSpecific[unit]) then
		return UnitSpecific[unit](self)
	end
end

oUF:RegisterStyle("InkedTargetTarget", Shared)
oUF:Factory(function(self)

	-----------------
	-- Unit Set Up --
	-----------------
	self:SetActiveStyle("InkedTargetTarget")
	--self:Spawn("targettarget"):SetPoint("CENTER",UIParent,"CENTER",235,-335)
	
	if Inked.db.profile.ToTPoint == nil then
		 self:Spawn("targettarget"):SetPoint("Center",UIParent,Inked.db.profile.ToTX,Inked.db.profile.ToTY)
		TartgetTargetMover:SetPoint("Center",UIParent,Inked.db.profile.ToTX,Inked.db.profile.ToTY)
	  else
		 self:Spawn("targettarget"):SetPoint(Inked.db.profile.ToTPoint,UIParent,Inked.db.profile.ToTX,Inked.db.profile.ToTY)
		TartgetTargetMover:SetPoint(Inked.db.profile.ToTPoint,UIParent,Inked.db.profile.ToTX,Inked.db.profile.ToTY)
	  end


end)

